config/routes.rb
Rails.application.routes.draw do
  resources :notes
  get 'statistics/show'
  get 'pages/no_project'
  get 'calendar/show'
  get 'pages/home'

  devise_for :users

  resources :projects do
    resources :tasks do
      resources :allocated_times do
        member do
          post :complete
          post :ignore
        end
      end

      member do
        post :complete
        post :uncomplete
      end
    end
  end

  root to: 'pages#home'
end

app/models/ability.rb
class Ability
  include CanCan::Ability

  def initialize(user)
    # Define abilities for the passed in user here. For example:
    #
    user ||= User.new # guest user (not logged in)
    can :manage, Project, user_id: user.id
    can :manage, User, user_id: user.id
    can :manage, Task, user_id: user.id
    can :manage, AllocatedTime, user_id: user.id
    can :manage, Note, user_id: user.id
    #
    # The first argument to `can` is the action you are giving the user
    # permission to do.
    # If you pass :manage it will apply to every action. Other common actions
    # here are :read, :create, :update and :destroy.
    #
    # The second argument is the resource the user can perform the action on.
    # If you pass :all it will apply to every resource. Otherwise pass a Ruby
    # class of the resource.
    #
    # The third argument is an optional hash of conditions to further filter the
    # objects.
    # For example, here the user can only update published articles.
    #
    #   can :update, Article, :published => true
    #
    # See the wiki for details:
    # https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
  end
end

app/models/allocated_time.rb
class AllocatedTime < ApplicationRecord
  belongs_to :task
  belongs_to :user
  default_scope -> { order(start: :asc) }
  #scope :done, -> () { where(done: true) }
  #scope :ignored, -> () { where(ignored: true) }
  validates :user_id, presence: true
  validates :task_id, presence: true
  validates :start, presence: true
  validates_datetime :end, after: :start, after_message: 'end must be after start'#, on_or_before: task.deadline, on_or_before_message: 'end must be on or before deadline'}

  def start_time
    self.start
  end

  def end_time
    self.end
  end

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/note.rb
class Note < ApplicationRecord
  belongs_to :user
  validates :title, presence: true
end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :user
  has_many :tasks, dependent: :destroy
  default_scope -> { order(created_at: :desc) }
  validates :user_id, presence: true
  validates :name, presence: true, length: { maximum: 100 }
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :project
  belongs_to :user
  has_many :allocated_times, dependent: :destroy
  default_scope -> { order(deadline: :asc) }
  scope :done, -> () { where(done: true) }
  validates :user_id, presence: true
  validates :project_id, presence: true
  validates :name, presence: true, length: { maximum: 100 }
  acts_as_taggable
end

app/models/user.rb
class User < ApplicationRecord
  has_many :projects, dependent: :destroy
  has_many :tasks, dependent: :destroy
  has_many :allocated_times, through: :tasks
  has_many :notes, dependent: :destroy
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :rememberable, :trackable, :validatable #:recoverable,
end

app/controllers/calendar_controller.rb
class CalendarController < ApplicationController

  def show
    @allocated_times = current_user.allocated_times.all
  end
end

app/controllers/notes_controller.rb
class NotesController < ApplicationController
  load_and_authorize_resource
  before_action :set_note, only: [:show, :edit, :update, :destroy]

  def index
    @notes = Note.all.where(user_id: current_user.id)
  end

  def new
    @note = Note.new
  end

  def edit
  end

  def create
    @note = Note.new(note_params)
    @note.user_id = current_user.id
    if @note.save
      flash[:success] = "Note created"
      redirect_to notes_path
    else
      render 'new'
    end
  end

  def update
    if @note.update(note_params)
      flash[:success] = 'Note edited'
      redirect_to notes_path
    else
      render 'edit'
    end
  end

  def destroy
    @note.destroy
    flash[:success] = "Note deleted"
    redirect_to notes_path
  end

  private
    def set_note
      @note = Note.find(params[:id])
    end

    def note_params
      params.require(:note).permit(:title, :content, :user_id)
    end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def home
     if user_signed_in?
       redirect_to statistics_show_path
     end
  end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  load_and_authorize_resource
  before_action :set_project, only: [:destroy, :edit, :update, :show]

  def new
    @project = Project.new
  end

  def show
    @show_all = params[:show_all] #to pass to allocated_times
    if params[:tag] # filter by tag
      @tasks = @project.tasks.all.tagged_with(params[:tag]) # when filtering by tag, always show all
    elsif params[:show_all]
      @tasks = @project.tasks.all
    else
      @tasks = @project.tasks.where(done: [false, nil])
    end
    tasks_ids = @project.tasks.all.map { |t| t.id}
    taggings = ActsAsTaggableOn::Tagging.all.where(taggable_id: tasks_ids)
    taggings_ids = taggings.map { |t| t.tag_id }
    @tags = ActsAsTaggableOn::Tag.all.where(id: taggings_ids) # all tags associated with any task in given project
    render 'tasks/index'
  end

  def index
    redirect_to project_tasks_url(@projects.first, @projects.first.tasks) # show tasks of first project
  end

  def edit
  end

  def update
    if @project.update(project_params)
      flash[:success] = 'Project renamed'
      redirect_to @project
    else
      render 'edit'
    end
  end

  def create
    @project = current_user.projects.build(project_params)
    if @project.save
      flash[:success] = "Project created"
      redirect_to @project
    else
      render 'new'
    end
  end

  def destroy
    @project.destroy
    flash[:success] = "Project deleted"
    if @projects.any?
      redirect_to @projects.first
    else
      render 'pages/no_project'
    end
  end

  private
    def set_project
      @project = Project.find(params[:id])
    end

    def project_params
      params.require(:project).permit(:name)
    end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  load_and_authorize_resource
  before_action :set_task, only: [:edit, :update, :destroy, :complete]
  before_action :set_project

  def new
    @task = Task.new
  end

  def show
  end

  def edit
  end

  def complete
    if @task.update_attributes(done: true)
      flash[:success] = 'Task completed'
    end
    redirect_to @project
  end

  def uncomplete
    if @task.update_attributes(done: false)
      flash[:success] = 'Task completed'
    end
    redirect_to @project
  end

  def update
    if @task.update(task_params)
      flash[:success] = 'Task edited'
      redirect_to @project
    else
      render 'edit'
    end
  end

  def create
    @task = @project.tasks.create(task_params)
    @task.user_id = current_user.id
    if @task.save
      flash[:success] = "Task created"
      redirect_to @project
    else
      flash[:danger] = 'Task not created'
      render 'new'
    end
  end

  def destroy
    @task.destroy
    flash[:success] = "Task deleted"
    redirect_to @project
  end

  private
    def set_task
      @task = Task.find(params[:id])
    end

    def set_project
      @project = Project.find(params[:project_id])
    end

    def task_params
      params.require(:task).permit(:project, :user, :name, :description, :deadline, :show_all, :tag_list)
    end
end

app/helpers/allocated_times_helper.rb
module AllocatedTimesHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/calendar_helper.rb
module CalendarHelper
end

app/helpers/notes_helper.rb
module NotesHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/statistics_helper.rb
module StatisticsHelper

  def pie_chart_time_by_status
    Gchart.pie(title: 'Time by status',
      data: [@length_done, @length_ignored, @length_all - @length_ignored - @length_done],
      labels: ['done', 'ignored', 'future'],
      theme: :greyscale )
  end

  def pie_chart_tasks_by_status
    Gchart.pie(title: 'Tasks by status',
      data: [@number_of_tasks_done, @number_of_tasks_all - @number_of_tasks_done],
      labels: ['done', 'future'],
      theme: :greyscale)
  end
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/layouts/_header.html.slim
header class="navbar navbar-static-top navbar-inverse"
  =link_to "Neverland", root_path, id: "logo"
  nav
    ul class="nav navbar-nav navbar-right"
      -if user_signed_in?
        li class="navbar-text"
          p ="Signed in as #{current_user.email}"
      -if user_signed_in?
        - if @projects.any?
          li =link_to 'Projects', project_path(@projects.first)
        -else
          li =link_to 'Projects', pages_no_project_path
        li =link_to 'Calendar', calendar_show_path
        li =link_to 'Statistics', statistics_show_path
        li =link_to 'Notes', notes_path
        li =link_to 'Settings', edit_user_registration_path
        li =link_to 'Logout', destroy_user_session_path, method: :delete
      -else
        li =link_to 'Sign up', new_user_registration_path
        li =link_to 'Log in', new_user_session_path

app/views/layouts/_messages.html.slim
-flash.each do |msg_type, msg|
  .alert class="alert-#{msg_type}"
    =msg

app/views/layouts/_project_list.html.slim
aside class="navbar navbar-inverse navbar-static-left"
  div id="wrapper_left"
    h3 Projects
    ul class="nav nav-pills nav-stacked"
      div class="navbar-btn"
        =link_to 'New Project', new_project_path, class: "btn btn-lg btn-primary"
      -if @projects.any?
        -@projects.each do |pr|
          =render 'projects/project', project: pr

app/views/layouts/_rails_default.html.slim
=csrf_meta_tags
=stylesheet_link_tag    'application', media: 'all',
                      'data-turbolinks-track': 'reload'
=javascript_include_tag 'application', 'data-turbolinks-track': 'reload'

app/views/layouts/_shim.html.slim
/[if lt IE 9]
  script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/r29/html5.min.js"

app/views/layouts/application.html.slim
doctype html
html
  head
    title Neverland
    =render 'layouts/rails_default'
    =render 'layouts/shim'

  body
    =render 'layouts/header'
    div id="wrapper"
      div id="sidebar-wrapper" class="col-md-2"
        - if user_signed_in?
          =render 'layouts/project_list'
      div id="content-wrapper" class="col-md-10"
        div class="container-fluid"
          div class="row"
            div class="col-md-12"
              =render 'layouts/messages'
              =yield

app/views/pages/home.html.slim
-if !user_signed_in?
  div class="center jumbotron"
    h1 Welcome to Neverland!
    =link_to "Sign up", new_user_registration_path, class: "btn btn-lg btn-primary"
    =" "
    =link_to 'Log in', new_user_session_path, class: "btn btn-lg btn-primary"

app/views/pages/no_project.html.slim
h2 Projects

p You have no projects. Create some!

=link_to 'New Project', new_project_path, class: "btn btn-lg btn-primary"

app/views/simple_calendar/_calendar.html.erb
<div class="simple-calendar">
  <div class="calendar-heading">
    <%= link_to t('simple_calendar.previous', default: 'Previous'), calendar.url_for_previous_view %>
    <span class="calendar-title"><%= t('date.month_names')[start_date.month] %> <%= start_date.year %></span>
    <%= link_to t('simple_calendar.next', default: 'Next'), calendar.url_for_next_view %>
  </div>

  <table class="table table-striped">
    <thead>
      <tr>
        <% date_range.slice(0, 7).each do |day| %>
          <th><%= t('date.abbr_day_names')[day.wday] %></th>
        <% end %>
      </tr>
    </thead>

    <tbody>
      <% date_range.each_slice(7) do |week| %>
        <tr>
          <% week.each do |day| %>
            <%= content_tag :td, class: calendar.td_classes_for(day) do %>
              <% if defined?(Haml) && respond_to?(:block_is_haml?) && block_is_haml?(block) %>
                <% capture_haml(day, sorted_events.fetch(day, []), &block) %>
              <% else %>
                <% block.call day, sorted_events.fetch(day, []) %>
              <% end %>
            <% end %>
          <% end %>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/simple_calendar/_month_calendar.html.erb
<div class="simple-calendar">
  <div class="calendar-heading">
    <%= link_to t('simple_calendar.previous', default: 'Previous'), calendar.url_for_previous_view , class: "btn btn-default"%>
    <span class="calendar-title"><%= t('date.month_names')[start_date.month] %> <%= start_date.year %></span>
    <%= link_to t('simple_calendar.next', default: 'Next'), calendar.url_for_next_view, class: "btn btn-default"%>
  </div>

  <table class="table table-striped">
    <thead>
      <tr>
        <% date_range.slice(0, 7).each do |day| %>
          <th><%= t('date.abbr_day_names')[day.wday] %></th>
        <% end %>
      </tr>
    </thead>

    <tbody>
      <% date_range.each_slice(7) do |week| %>
        <tr>
          <% week.each do |day| %>
            <%= content_tag :td, class: calendar.td_classes_for(day) do %>
              <% if defined?(Haml) && respond_to?(:block_is_haml?) && block_is_haml?(block) %>
                <% capture_haml(day, sorted_events.fetch(day, []), &block) %>
              <% else %>
                <% block.call day, sorted_events.fetch(day, []) %>
              <% end %>
            <% end %>
          <% end %>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/simple_calendar/_week_calendar.html.erb
<div class="simple-calendar">
  <div class="calendar-heading">
    <%= link_to t('simple_calendar.previous', default: 'Previous'), calendar.url_for_previous_view %>
    <span class="calendar-title">Week <%= calendar.week_number %></span>
    <%= link_to t('simple_calendar.next', default: 'Next'), calendar.url_for_next_view %>
  </div>

  <table class="table table-striped">
    <thead>
      <tr>
        <% date_range.slice(0, 7).each do |day| %>
          <th><%= t('date.abbr_day_names')[day.wday] %></th>
        <% end %>
      </tr>
    </thead>

    <tbody>
      <% date_range.each_slice(7) do |week| %>
        <tr>
          <% week.each do |day| %>
            <%= content_tag :td, class: calendar.td_classes_for(day) do %>
              <% if defined?(Haml) && respond_to?(:block_is_haml?) && block_is_haml?(block) %>
                <% capture_haml(day, sorted_events.fetch(day, []), &block) %>
              <% else %>
                <% block.call day, sorted_events.fetch(day, []) %>
              <% end %>
            <% end %>
          <% end %>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>